CF478B Random Teams

CF478B Random Teams

结论题,难度不高。

首先根据经验以及观察样例可以猜到:

  • 要使答案最小,需要尽可能平均分配。
  • 要使答案最大,需要 m − 1 m-1 m−1 个组每组 1 1 1 个人, 1 1 1 个组 n − m + 1 n-m+1 n−m+1 个人。

那么这个结论是否正确呢?

考虑只有两个组,一个组 a a a 人,一个组 b b b 人,令 a > b ≥ 2 a>b\ge2 a>b≥2。则现在的朋友数量为 a ( a − 1 ) + b ( b − 1 ) 2 \dfrac{a(a-1)+b(b-1)}{2} 2a(a−1)+b(b−1)。

如果从第一个组中抽一个人给第二个组,则朋友数量变为
( a − 1 ) ( a − 2 ) + b ( b + 1 ) 2 = a 2 − 3 a + 2 + b 2 + b 2 = a ( a − 1 ) + b ( b − 1 ) − 2 a + b + 2 2 \dfrac{(a-1)(a-2)+b(b+1)}{2}=\dfrac{a^2-3a+2+b^2+b}{2}=\dfrac{a(a-1)+b(b-1)-2a+b+2}{2} 2(a−1)(a−2)+b(b+1)=2a2−3a+2+b2+b=2a(a−1)+b(b−1)−2a+b+2

又因为要求 a > b ≥ 2 a>b\ge2 a>b≥2,所以 − 2 a + b + 2 < 0 -2a+b+2<0 −2a+b+2<0,所以平均分配人答案最小,把人集中到一个组答案最大。

cpp 复制代码
#include <bits/stdc++.h>
#define int long long
using namespace std;
typedef long long LL;
const int N = 1e6 + 10;
int n, m, ans1, ans2;
signed main () {
	ios::sync_with_stdio (false);
	cin.tie (0); cout.tie (0);
	
	cin >> n >> m;
	int x = n / m;
	if (n % m) ans1 += (n % m) * (x + 1) * x / 2;
	ans1 += (m - n % m) * x * (x - 1) / 2;
	int p = n - (m - 1);
	ans2 = p * (p - 1) / 2;
	cout << ans1 << ' ' << ans2;
	return 0;
}
相关推荐
木井巳1 小时前
【动态规划: 线性dp】解码方法
java·算法·leetcode·动态规划·推荐算法
春弦_9 小时前
自用算法整理二
数据结构·算法·图论
hetao173383710 小时前
2026-10-22~23 hetao1733837 的刷题记录
c++·算法
java_nnnn10 小时前
LeetCode刷题滑动窗口(串联所有单词的子串+最小覆盖的子串)Java
算法·leetcode·职场和发展
王老师青少年编程10 小时前
2025年6月GESP真题及题解(C++三级): 选择题和判断题(题解)
c++·真题·gesp·答案·csp·三级·信奥赛
Navigator_Z11 小时前
LeetCode //C - 1301. Number of Paths with Max Score
c语言·算法·leetcode
卡卡~~11 小时前
“101计划”核心课程实践教材《数据实验结构指导-C++语言版》题目集
开发语言·c++·学习·算法
企业数字化笔记12 小时前
AI视频增强后画质怎么验收?插值基线、伪细节与帧间闪烁的检查方法
人工智能·算法·音视频
学逆向的12 小时前
C 内存属性
c语言·开发语言·算法·网络安全